﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace WAZSMApiClient
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            if (App.SavedSubscriptions.Count == 0)
            {
                GridNoSubscriptions.Visibility = Windows.UI.Xaml.Visibility.Visible;
                GridSubscriptions.Visibility = Windows.UI.Xaml.Visibility.Collapsed;
            }
            else
            {
                GridNoSubscriptions.Visibility = Windows.UI.Xaml.Visibility.Collapsed;
                GridSubscriptions.Visibility = Windows.UI.Xaml.Visibility.Visible;
                ListViewSubscriptions.ItemsSource = null;
                ListViewSubscriptions.ItemsSource = App.SavedSubscriptions;
            }
        }

        private void ButtonAddSubscription_Click_1(object sender, RoutedEventArgs e)
        {
            AddSubscription();
        }

        private void AddSubscription()
        {
            Frame rootFrame = Window.Current.Content as Frame;
            rootFrame.Navigate(typeof(Pages.SetupSubscription));
        }

        private void ButtonViewSubscription_Click_1(object sender, RoutedEventArgs e)
        {
            var subscriptionItem = ListViewSubscriptions.SelectedItem as SavedSubscription;
            Frame rootFrame = Window.Current.Content as Frame;
            rootFrame.Navigate(typeof(Pages.StorageAccounts), subscriptionItem);
        }

        private void ListViewSubscriptions_SelectionChanged_1(object sender, SelectionChangedEventArgs e)
        {
            ButtonViewSubscription.IsEnabled = false;
            if (ListViewSubscriptions.SelectedItem != null)
            {
                ButtonViewSubscription.IsEnabled = true;
                MainPageAppBar.IsOpen = true;
            }
        }
    }
}
